import { Config } from "jest";
import { pathsToModuleNameMapper } from "ts-jest";
import { compilerOptions } from "./tsconfig.json";

var config: Config = {
    preset: "ts-jest",
    setupFilesAfterEnv: ["./test_setup/global_mocks.ts"],
    //globalSetup: "./test_setup/global_setup.ts",
    //globalTeardown: "./test_setup/global_teardown.ts",
    collectCoverage: true,
    coverageProvider: "v8",
    moduleFileExtensions: ["ts", "tsx", "js", "jsx", "json", "node"],
    collectCoverageFrom: ["src/**"],
    modulePaths: [compilerOptions.baseUrl], // <-- This will be set to 'baseUrl' value
    moduleNameMapper: pathsToModuleNameMapper(
        compilerOptions.paths /*, { prefix: '<rootDir>/' } */,
    ),
    verbose: true,
};

export default config;
