/* eslint-disable @typescript-eslint/no-explicit-any */
import React, { useState } from "react";

import {
    JoinedNumbersInput,
    JoinedRangeNumberInput,
    NumberInput,
    RangeInput,
} from "components/form/inputs/number";

const NumberInputs = ({ showValid, showInvalid }) => {
    const [number, setNumber] = useState(5);

    const components = [
        {
            Component: NumberInput,
            value: number,
            onInput: (e) => setNumber(e.target.value),
        },
        {
            Component: RangeInput,
            value: number,
            onInput: (e) => setNumber(e.target.value),
        },
        {
            Component: JoinedRangeNumberInput,
            value: number,
            onInput: (e) => setNumber(e.target.value),
        },
        {
            Component: JoinedNumbersInput,
            values: [number, number],
            onInput: (e) => setNumber(e.target.value),
        },
    ];

    return components.map(({ Component, ...props }, index) => (
        <div key={index} className="mb-3 d-flex flex-column gap-2">
            <h3>{Component.name}</h3>
            <Component {...(props as any)} />
            {showValid && (
                <>
                    <Component
                        {...(props as any)}
                        isValid
                        validFeedback="correct"
                    />
                    <Component
                        {...(props as any)}
                        isValid
                        validFeedback="correct"
                        onReset={() => {}}
                    />
                </>
            )}
            {showInvalid && (
                <>
                    <Component
                        {...(props as any)}
                        isInvalid
                        invalidFeedback="wrong"
                    />
                    <Component
                        {...(props as any)}
                        isInvalid
                        invalidFeedback="wrong"
                        onReset={() => {}}
                    />
                </>
            )}
        </div>
    ));
};

export default NumberInputs;
