import { createContext, useContext } from "react";

import { type ID } from "@snip/database/types";

import { ToolContextProps } from "../types";

export interface PointerContextI {
    sendPos: (xy_db: [number, number], pageId: ID) => void;
}

const PointerContext = createContext<PointerContextI>({
    sendPos: () => {},
});

export function PointerContextProvider({ children }: ToolContextProps) {
    function sendPos(xy_db, pageId) {
        console.log(pageId);
    }

    return (
        <PointerContext.Provider value={{ sendPos }}>
            {children}
        </PointerContext.Provider>
    );
}

export function usePointerContext() {
    return useContext(PointerContext);
}
